#include <stdio.h>
#include "windows.h"

#define UPPERLOOP 999999999

class PerfTimer
{
private:
	LARGE_INTEGER Frequency;
	LARGE_INTEGER StartTime;
	LARGE_INTEGER EndTime;

public:
	char szDuration[50];

public:
	PerfTimer::PerfTimer(void)
	{
		QueryPerformanceFrequency(&Frequency);
		ZeroMemory(szDuration, sizeof(szDuration) / sizeof(char));
	}

	void Start(void)
	{
		QueryPerformanceCounter(&StartTime);
	}

	void Stop(void)
	{
		QueryPerformanceCounter(&EndTime);
		ZeroMemory(szDuration, sizeof(szDuration) / sizeof(char));

		LARGE_INTEGER LagStartTime;
		LARGE_INTEGER LagEndTime;

		QueryPerformanceCounter(&LagStartTime);
		QueryPerformanceCounter(&LagEndTime);

		EndTime.QuadPart = EndTime.QuadPart - (LagEndTime.QuadPart - LagStartTime.QuadPart);
	}

	LONGLONG Nanoseconds(void)
	{
		return (1000000000 * (EndTime.QuadPart - StartTime.QuadPart)) / Frequency.QuadPart;
	}

	LONGLONG Microseconds(void)
	{
		return (1000000 * (EndTime.QuadPart - StartTime.QuadPart)) / Frequency.QuadPart;
	}

	LONGLONG Milliseconds(void)
	{
		return (1000 * (EndTime.QuadPart - StartTime.QuadPart)) / Frequency.QuadPart;
	}

	LONGLONG Seconds(void)
	{
		return (EndTime.QuadPart - StartTime.QuadPart) / Frequency.QuadPart;
	}

	LONGLONG Minutes(void)
	{
		return ((EndTime.QuadPart - StartTime.QuadPart) / Frequency.QuadPart) / 60;
	}

	LONGLONG Hours(void)
	{
		return (((EndTime.QuadPart - StartTime.QuadPart) / Frequency.QuadPart) / 60) / 60;
	}

	LONGLONG Days(void)
	{
		return ((((EndTime.QuadPart - StartTime.QuadPart) / Frequency.QuadPart) / 60) / 60) / 24;
	}

	void CalculateDuration(void)
	{
		LONGLONG liDifference1;
		LONGLONG liDifference2;

		liDifference1 = (EndTime.QuadPart - StartTime.QuadPart) / Frequency.QuadPart;
		liDifference2 = (EndTime.QuadPart - StartTime.QuadPart);

		sprintf(szDuration, "%I64d-%2I64d:%2I64d:%2I64d.%3I64d.%3I64d.%3I64d", 
			((liDifference1 / 60) / 60) / 24, 
			((liDifference1 / 60) / 60) % 24, 
			(liDifference1 / 60) % 60, 
			liDifference1 % 60, 
			((liDifference2 * 1000) / Frequency.QuadPart) % 1000, 
			((liDifference2 * 1000000) / Frequency.QuadPart) % 1000, 
			((liDifference2 * 1000000000) / Frequency.QuadPart) % 1000);
		
		for (size_t iCharIndex = 0; iCharIndex < strlen(szDuration); ++iCharIndex)
		{
			if (szDuration[iCharIndex] == ' ')
			{
				szDuration[iCharIndex] = '0';
			}
		}
	}
};

void test1(void)
{
	long ii = 1;
	long jj = 0;

	for(ii = 1; ii < UPPERLOOP; ++ii)
	{
		++jj;
	}
}

void test2(void)
{
	long ii = 1;
	long jj = 0;

	for(ii = 1; ii < UPPERLOOP; ++ii)
	{
		__asm 
		{
			mov ebx, jj
			add ebx, 1
			mov jj, ebx
		}
	}
}

void test3(void)
{
	long ii = 1;
	long jj = 0;

	__asm
	{
		mov ecx, ii
		cmp ecx, UPPERLOOP
		jge jumpdone
		jmp jumpwork
	jumpcondition:
		cmp ecx, UPPERLOOP
		jge jumpdone
	jumpwork:
		mov ebx, jj
		add ebx, 1
		mov jj, ebx
	;jumpincrease
		add ecx, 1
		jmp jumpcondition
	jumpdone:
	}
}

int main(void)
{
	PerfTimer nst1;
	PerfTimer nst1b;
	PerfTimer nst2;
	PerfTimer nst2b;
	PerfTimer nst2c;
	PerfTimer nst3;
	PerfTimer nst4;

	printf("\r\n");

	nst1.Start();
	test1();
	nst1.Stop();
	nst1.CalculateDuration();
	printf("c++   (plain loop)    : %s\r\n", nst1.szDuration);

	nst2.Start();
	test2();
	nst2.Stop();
	nst2.CalculateDuration();
	printf("mix   (c++ and __asm) : %s\r\n", nst2.szDuration);

	nst3.Start();
	test3();
	nst3.Stop();
	nst3.CalculateDuration();
	printf("__asm (__asm *)       : %s\r\n", nst3.szDuration);

	printf("\r\n\a");

        return 0;
}
